#!/usr/bin/python2

import csv
import os
from subprocess import call
import sys

if len( sys.argv ) < 3:
    print "Usage:", sys.argv[ 0 ], "piece variants..."

piece    = sys.argv[ 1 ]
variants = sys.argv[ 2: ]

root = os.path.abspath( os.path.dirname( sys.argv[ 0 ] ) )
compile = os.path.join( root, "compile.sh" )

def silent( *args, **kwargs ):
    with open( "/dev/null", 'w' ) as devnull:
        kwargs[ "stdout" ] = devnull
        kwargs[ "stderr" ] = devnull
        return call( *args, **kwargs )

fitnessdir = set( map( os.path.dirname, variants ) )
if len( fitnessdir ) == 1:
    fitness = os.path.join( fitnessdir.pop(), "fitness.csv" )
else:
    fitness = "fitness.csv"

print "Preparing sample images..."
sys.stdout.flush()

with open( fitness, 'w' ) as fh:
    writer = csv.writer( fh )
    writer.writerow( [ "file", "time", "error" ] )
    for variant in variants:
        base = os.path.basename( piece )
        if variant.endswith( base ):
            base = variant[ : -( len( base ) + 1 ) ]
        else:
            base = os.path.splitext( variant )[ 0 ].rstrip( "." )

        print base
        if silent( [ compile, piece, variant ] ) == 0:
            silent( [ "src/glass", "-A", "-B", "-s=test" ] )
            if os.path.exists( "test.ppm" ):
                os.rename( "test.ppm", base + ".ppm" )
        if os.path.exists( base + ".fitness" ):
            with open( base + ".fitness" ) as fh:
                writer.writerow( [ base ] + csv.reader( fh ).next() )
        else:
            print "WARNING: could not find fitness for", base

